<p align="center"><img src="https://img.alicdn.com/tfs/TB1r74NJyLaK1RjSZFxXXamPFXa-1024-1024.png" align="center" width="175"></p>
<h1 align="center">Fish Redux</h1>

[![Build Status](https://travis-ci.org/alibaba/fish-redux.svg?branch=master)](https://travis-ci.org/alibaba/fish-redux) [![pub package](https://img.shields.io/pub/v/fish_redux.svg)](https://pub.dartlang.org/packages/fish_redux) [![codecov](https://codecov.io/gh/alibaba/fish-redux/branch/master/graph/badge.svg)](https://codecov.io/gh/alibaba/fish-redux)

## What is Fish Redux ?

Fish Redux is an assembled flutter application framework based on Redux state management.
It is suitable for building medium and large applications.

It has four characteristics:

> 1. Functional Programming

> 2. Predictable state container

> 3. Pluggable componentization

> 4. Non-destructive performance

## Architecture diagram

<img src="https://img.alicdn.com/tfs/TB1pkhoJr2pK1RjSZFsXXaNlXXa-1004-1370.png" width="500px" height="680px">

## Installation

[Go](https://pub.dartlang.org/packages/fish_redux#-installing-tab-)

## Documentation

Language: [English](doc/README.md) | [中文简体](doc/README-cn.md)

## Examples

-   [todo list](example) - a simple todo list demo.
-   run it:

```
cd ./example
flutter create .
flutter run
```

## What's the difference between 'Fish Redux' and 'Redux' ?

-   [answers](doc/concept/what's-the-diiference.md)

## Plugins

### Code Template

-   [Fish Redux Template For Android Studio](https://github.com/BakerJQ/FishReduxTemplateForAS), by BakerJQ.
-   [Fish Redux Template For VSCode](https://github.com/huangjianke/fish-redux-template), by huangjianke.

### Dev-Tools

-   Redux Inspector (using [Flutter Debugger](https://github.com/blankapp/flutter-debugger) and [flipperkit_fish_redux_middleware](https://pub.dartlang.org/packages/flipperkit_fish_redux_middleware)) for Fish Redux apps, by [JianyingLi](https://github.com/lijy91)

## License

-   Fish Redux is released under the Apache 2.0 license. See [LICENSE](LICENSE) for details.


## 关于我们
阿里巴巴-闲鱼技术是国内最早也是最大规模线上运行Flutter的团队。

我们在公众号中为你精选了Flutter独家干货，全面而深入。

内容包括：Flutter的接入、规模化应用、引擎探秘、工程体系、创新技术等教程和开源信息。

**架构／服务端／客户端／前端／质量工程师 在公众号中投递简历，名额不限哦**

欢迎来闲鱼做一个好奇、幸福、有影响力的程序员，简历投递：tino.wjf@alibaba-inc.com

订阅地址

<img src="https://img.alicdn.com/tfs/TB17Ki5XubviK0jSZFNXXaApXXa-656-656.png" width="328px" height="328px">

[For English](https://twitter.com/xianyutech "For English")
